/*  
 * Hydra 0.4 - a parallel login hacker 
 * (c) 2000 by Van Hauser / THC <vh@reptile.rug.ac.be>, 
 *             Plasmoid / THC <plasmoid@pimmel.com> 
 * The Hacker's Choice - http://www.infowar.co.uk/thc 
 */

#include "hydra-mod.h"

int intern_socket, extern_socket;
char pair[260];
char HYDRA_EXIT[5] = "\x00\xff\x00\xff\x00";
char *HYDRA_EMPTY = "\x00\x00\x00\x00";

void alarming()
{
    fprintf(stderr, "Process %d: Can not connect, process exiting\n",
	    getpid());
    hydra_child_exit();
}

void hydra_child_exit()
{
    write(intern_socket, "Q", 1);
    exit(-1);
}

void hydra_register_socket(int s)
{
    intern_socket = s;
}

char *hydra_get_next_pair()
{
    if (pair[0] == 0) {
	read(intern_socket, pair, sizeof(pair));
	if (memcmp(&HYDRA_EXIT, &pair, sizeof(HYDRA_EXIT)) == 0)
	    return HYDRA_EXIT;
	if (pair[0] == 0)
	    return HYDRA_EMPTY;
    }
    return pair;
}

char *hydra_get_next_login()
{
    if (pair[0] == 0)
	return HYDRA_EMPTY;
    return pair;
}

char *hydra_get_next_password()
{
    char *ptr = pair;
    if (pair[0] == 0)
	return HYDRA_EMPTY;
    while (*ptr != '\0')
	ptr++;
    ptr++;
    return ptr;
}

void hydra_completed_pair()
{
    pair[0] = 0;
    write(intern_socket, "N", 1);
}

void hydra_report_found(FILE * fp)
{
    fprintf(fp, "Found! login: %s   password: %s\n",
	    hydra_get_next_login(), hydra_get_next_password());
}

int hydra_connect_tcp(unsigned long int host, int port)
{
    int s, ret = -1;
    struct sockaddr_in target;
    if ((s = socket(PF_INET, SOCK_STREAM, 6)) >= 0) {
	target.sin_port = htons(port);
	target.sin_family = AF_INET;
	memcpy(&target.sin_addr.s_addr, &host, 4);
	signal(SIGALRM, alarming);
	alarm(20);
	ret = connect(s, &target, sizeof(target));
	alarm(0);
	if (ret >= 0) {
	    ret = s;
	    extern_socket = s;
	}
    }
    return ret;
}

int hydra_disconnect(int socket)
{
    close(socket);
    return -1;
}

int hydra_data_ready(int socket)
{
    fd_set fds;
    struct timeval tv;

    FD_ZERO(&fds);
    FD_SET(socket, &fds);
    tv.tv_sec = 0;
    tv.tv_usec = 100;
    return (select(1, &fds, NULL, NULL, &tv));
}

char *hydra_receive_line(int socket)
{
    char buf[300], *buff;
    int i, j;

    buff = malloc(sizeof(buf));
    memset(buff, 0, sizeof(buf));
    if ((i = recv(socket, buff, sizeof(buf), 0)) < 0) {
	free(buff);
	return NULL;
    }
    while (hydra_data_ready(socket)) {
	j = recv(socket, buf, sizeof(buf), 0);
	buff = realloc(buff, i + j);
	memcpy(buff + i, &buf, j);
	i = i + j;
    }

    return buff;
}

int hydra_send(int socket, char *buf, int size, int options)
{
    return (send(socket, buf, size, options));
}
